#!/bin/bash

# Construct the ACS source from the original file.
cd build_files
cat ../src/acs_source/ZMEMORY.acs | ../meta_src/metatool.out ZMEMORY.acs ZMEMORY_g.acs ZMEMORY_w.acs ../acs_interface/ZMEMORY.acs ../acs_interface/ZMEMORY_g.acs ../acs_interface/ZMEMORY_w.acs

# compile the ACS source
acc -i $ACC_ZCOMMON_PATH ZMEMORY.acs ../src/acs/ZMEMORY.o

cd ../src
# Bundle everything that isn't:
#  .sh  : a shell script.
thin_arg=$1
version=$(cat ../version.txt)
if [[ $thin_arg == "thin" ]]; then
  7za a -tzip ../ZMemory_v$version\_thin.pk3 -r -x\!*.sh -x\!acs/.gitignore -xr\!acs_source
else
  7za a -tzip ../ZMemory_v$version.pk3 -r -x\!*.sh -x\!acs/.gitignore
fi

cd ../acs_interface
# This is some weird derpiness.
# The files are however small, so it isn't a big deal.
echo "" >> ZMEMORY.acs #newline
cat ZMEMORY_g.acs >> ZMEMORY.acs
echo "" >> ZMEMORY.acs #newline
cat ZMEMORY_w.acs >> ZMEMORY.acs

rm ZMEMORY_g.acs
rm ZMEMORY_w.acs

